SystemOrganization addCategory: #SistemaWeb!

WAComponent subclass: #LoginComponent
	instanceVariableNames: 'name password user warning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!LoginComponent methodsFor: 'rendering' stamp: 'tgn 6/30/2013 13:59'!
renderContentOn: html
	(html div)
		class: 'login-container';
		with: [ 
					html heading: warning.
					html
						form: [ 
							(html textInput)
								text: 'name';
								callback: [ :value | name := value ].
							(html passwordInput)
								text: 'password';
								callback: [ :value | password := value ].
							(html submitButton)
								text: 'Login';
								callback: [ 
											user := UserManager singleton
												login:
													{name.
													password}.
											user
												ifNil: [ warning := 'Incorrect login.' ];
												ifNotNil: [ self answer: user ] ] ] ]! !

WAComponent subclass: #MainComponent
	instanceVariableNames: 'login loggedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!MainComponent class methodsFor: 'class initialization' stamp: 'HGPL 6/29/2013 21:22'!
initialize
	WAAdmin register: self asApplicationAt: 'poo'! !

!MainComponent methodsFor: 'initialization' stamp: 'tgn 6/30/2013 13:44'!
initialize
	super initialize.
	login := LoginComponent new.
	loggedUser := User new.! !

!MainComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 14:28'!
renderContentOn: html
	(UserManager singleton isLoggedUser: loggedUser)
		ifFalse: [ 
			html text: loggedUser email.
			(html div)
				class: 'header';
				with: [ 
							(html anchor)
								callback: [ loggedUser := self call: LoginComponent new ];
								with: 'Login'.
							html break.
							(html anchor)
								callback: [ 
											loggedUser := self call: SignUpComponent new.
											UserManager singleton login: { loggedUser username . loggedUser password  }];
								with: 'Sign Up' ].
			html horizontalRule ]
		ifTrue: [ 
			(html div)
				class: 'header';
				with: [ html text: 'Welcome, ', loggedUser username, '!!' ].
			(html div)
				class: 'body';
				with: [   NewTopicComponent new
						user: loggedUser;
						renderContentOn: html. ]
				 ]! !

!MainComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 11:57'!
style ^ 'div.header {
   height: 30px;
}

div.login-container {
   width: 350px;
   float: right;
   display: block;
}'! !

WAComponent subclass: #NewTopicComponent
	instanceVariableNames: 'name warning description moderators user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!NewTopicComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 14:22'!
initialize
	super initialize.! !

!NewTopicComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 14:28'!
renderContentOn: html
	html heading: warning.
	
	html heading: 'Create a new topic:' .
	  
	html
		form: [ 
			html text: 'Name:'.
			html textInput callback: [ :value | name := value ].
			html break.
			html text: 'Description'.
			html textInput callback: [ :value | description := value ].
			html break.
			html text: 'Moderators'.
			html textInput callback: [ :value | moderators := value ].
			html break.
			html submitButton
				callback: [ warning := 'TODO: criar Programa e adicionar no banco'. ] .
				].
			! !

!NewTopicComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 14:22'!
user: loggedUser
	user := loggedUser.! !

WAComponent subclass: #SignUpComponent
	instanceVariableNames: 'name email password user warning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!SignUpComponent methodsFor: 'convenience' stamp: 'tgn 6/30/2013 13:01'!
createNewUserWithName: userName andPassword: userPW andEmail: userEmail
	user := UserManager singleton
		register:
			(Dictionary
				newFrom:
					{('username' -> userName).
					('password' -> userPW).
					('email' -> userEmail)}).
	^ user! !

!SignUpComponent methodsFor: 'rendering' stamp: 'FA 6/29/2013 22:16'!
initialize
	super initialize.
	user := nil.! !

!SignUpComponent methodsFor: 'rendering' stamp: 'tgn 6/30/2013 13:57'!
renderContentOn: html
	html heading: warning.
	html
		form: [ 
			html text: 'Name:'.
			html textInput callback: [ :value | name := value ].
			html break.
			html text: 'Email:'.
			html textInput callback: [ :value | email := value ].
			html break.
			html text: 'Password:'.
			html passwordInput callback: [ :value | password := value ].
			html break.
			html submitButton
				callback: [ 
					(user := self createNewUserWithName: name andPassword: password  andEmail:  email)
						ifNil: [ warning := 'Sorry, user already exists.' ];
						ifNotNil: [ self answer: user ] ] ]! !
MainComponent initialize!
